/**
 * Created by MeePwn
 * https://github.com/maybewaityou
 *
 * description:
 *
 */

const describe = require('mocha').describe;
const it = require('mocha').it;
const expect = require('chai').expect;
const Observable = require('rxjs').Observable;

const tagStringTemplate = (strings, ...raw) => {
  console.log(strings);
  console.log(raw);
};

const change = (object, onChange) => {
  const handler = {
    get(target, property, receiver) {
      try {
        return new Proxy(target[property], handler);
      } catch (err) {
        return Reflect.get(target, property, receiver);
      }
    },
    defineProperty(target, property, descriptor) {
      onChange(property);
      return Reflect.defineProperty(target, property, descriptor);
    },
    deleteProperty(target, property) {
      onChange(property);
      return Reflect.deleteProperty(target, property);
    }
  };

  return new Proxy(object, handler);
};

describe('', () => {
  it('', () => {
    // const testObject = {
    //   name: 'zhangsan',
    //   age: 15,
    //   dog: {
    //     name: 'wangcai',
    //     age: 3
    //   }
    // };
    // const object = change(testObject, (key) => {
    //   console.log(`== key ===>>>> ${key}`);
    // });
    // object.name = 'lisi';
    // object.age = 13;
    // object.dog = {
    //   name: 'wangwang',
    //   age: 4
    // };
    // console.log(object);

    const params0 = 'this is params0 ~';
    const params1 = 'this is params1 ~';
    // tagStringTemplate`== test tag string template ===>>>> ${params0} ${params1}`;
    expect(params0).to.be.equal(params1);
  });
});
